#include "bme2wav.h"
#include <stdio.h>

char *MainFrame::class_name = "BME2WAV";

bool MainFrame::init( HINSTANCE h_instance ) {
  // EBhENX̍쐬Ao^
  WNDCLASS window_class;
  window_class.style         = CS_HREDRAW|CS_VREDRAW;
  window_class.lpfnWndProc   = TtWindow::_ttl_wnd_proc;
  window_class.cbClsExtra    = 0;
  window_class.cbWndExtra    = 0;
  window_class.hInstance     = h_instance;
  window_class.hIcon         = LoadIcon( h_instance, "MAIN_ICON" );
  window_class.hCursor       = LoadCursor( NULL, IDC_ARROW );
  window_class.hbrBackground = (HBRUSH)(COLOR_MENU + 1);
  window_class.lpszMenuName  = NULL;
  window_class.lpszClassName = MainFrame::class_name;

  return RegisterClass( &window_class );
}

DWORD  FileEdit::get_ex_style()   { return WS_EX_CLIENTEDGE; }
DWORD  FileEdit::get_style()      { return ES_LEFT | ES_AUTOHSCROLL; }

DWORD  MainFrame::get_ex_style()   { return WS_EX_STATICEDGE | WS_EX_ACCEPTFILES; }
DWORD  MainFrame::get_style()      { return WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX ; }
PCTSTR MainFrame::get_class_name() { return MainFrame::class_name; }

bool MainFrame::created() {
  HFONT h_font = CreateFont(
    12, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
    SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
    CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY ,
    FIXED_PITCH | FF_MODERN , NULL
    );
  
  input_label  = new TtStatic();
  input_edit   = new FileEdit();
  input_button = new TtButton();
  output_label  = new TtStatic();
  output_edit   = new FileEdit();
  output_button = new TtButton();

  input_label->create(   this, 0,             this->h_instance, 0 );
  input_edit->create(    this, 0,             this->h_instance, 0 );
  input_button->create(  this, ID_IN_BUTTON,  this->h_instance, 0 );
  output_label->create(  this, 0,             this->h_instance, 0 );
  output_edit->create(   this, 0,             this->h_instance, 0 );
  output_button->create( this, ID_OUT_BUTTON, this->h_instance, 0 );

  volume_label = new TtStatic();
  volume_edit  = new TtEdit();
  volume_label->create( this, 0, this->h_instance, 0 );
  volume_edit->create(  this, 0, this->h_instance, 0 );

  resounding_check = new TtCheckBox();
  resounding_check->create( this, 0, this->h_instance, 0 );
  resounding_check->set_check( true );
  
  progress = new TtProgress();
  progress->create( this, 0, this->h_instance, 0 );
  progress->set_max( 200 );
  progress->set_step( 1 );

  exec_button = new TtButton();
  exec_button->create( this, ID_EXE_BUTTON, this->h_instance, 0 );

  info_label = new TtStatic();
  info_label->create( this, 0, this->h_instance, 0 );

  input_label->set_pos_size(        5,  14,  25, 20 );
  output_label->set_pos_size(       5,  44,  25, 20 );
  volume_label->set_pos_size(       5,  74,  55, 20 );
  input_edit->set_pos_size(        40,  10, 350, 20 );
  output_edit->set_pos_size(       40,  40, 350, 20 );
  volume_edit->set_pos_size(       70,  70,  50, 20 );
  input_button->set_pos_size(     400,  10,  50, 20 );
  output_button->set_pos_size(    400,  40,  50, 20 );
  resounding_check->set_pos_size( 150,  70, 210, 20 );
  
  exec_button->set_pos_size(   400, 100,  50, 30 );
  progress->set_pos_size(        5, 100, 384, 30 );
  info_label->set_pos_size(      5, 135, 460, 20 );

  input_label->set_text(      "" );
  input_button->set_text(     "Q" );
  output_label->set_text(     "o" );
  output_button->set_text(    "Q" );
  volume_label->set_text(     "( % )" );
  volume_edit->set_text(      "50" );
  resounding_check->set_text( "WAVĂÔȂ" );
  exec_button->set_text(      "ϊ" );
  info_label->set_text(       "BMSt@Cw肵ĕϊ{^I" );
  
  input_label->show();
  input_edit->show();
  input_button->show();
  output_label->show();
  output_edit->show();
  output_button->show();
  volume_label->show();
  volume_edit->show();
  resounding_check->show();
  progress->show();
  exec_button->show();
  info_label->show();
  
  input_label->set_font( h_font );
  input_edit->set_font( h_font );
  input_button->set_font( h_font );
  output_label->set_font( h_font );
  output_edit->set_font( h_font );
  output_button->set_font( h_font );
  volume_label->set_font( h_font );
  volume_edit->set_font( h_font );
  resounding_check->set_font( h_font );
  progress->set_font( h_font );
  exec_button->set_font( h_font );
  info_label->set_font( h_font );
  
  return true;
}


LRESULT MainFrame::wm_command_recved( int id, int code, HWND child ) {
  code; child; // x}~̈
  
  switch ( id ) {
  case ID_IN_BUTTON:
    if ( !BME2WAV::get_open_filename( this->h_wnd, BME2WAV::buf, sizeof( BME2WAV::buf ) ) ) { return 0; }
    this->input_edit->set_text( BME2WAV::buf );
    TtPath::edit_path( BME2WAV::buf, true, true, true, false );
    strcat( BME2WAV::buf, ".wav" );
    this->output_edit->set_text( BME2WAV::buf );
    return 0;

  case ID_OUT_BUTTON:
    if ( !BME2WAV::get_save_filename( this->h_wnd, BME2WAV::buf, sizeof( BME2WAV::buf ) ) ) { return 0; }
    this->output_edit->set_text( BME2WAV::buf );
    return 0;

  case ID_EXE_BUTTON:
    {
      BmsConverter *converter = new BmsConverter();
      this->input_edit->get_text( BME2WAV::buf, sizeof( BME2WAV::buf ) );
      converter->set_bms_path( BME2WAV::buf );
      BmsBms *bms = converter->open_bms();
      if ( bms == NULL_BMS ) {
        sprintf( BME2WAV::buf, "line %d : %s", BmsLexer::get_last_error_line_num(), BmsLexer::get_last_error_str() );
        MessageBox( this->h_wnd, BME2WAV::buf, "BMSt@C͎s", MB_ICONERROR );
        delete converter;
        return 0;
      }
      this->output_edit->get_text( BME2WAV::buf, sizeof( BME2WAV::buf ) );
      if ( PathFileExists( BME2WAV::buf ) ) {
        char _tmp[1024];
        sprintf( _tmp, "%s\nt@C㏑܂H", BME2WAV::buf );
        if ( MessageBox( this->h_wnd, _tmp, "mF", MB_YESNO | MB_ICONQUESTION ) == IDNO ) {
          delete converter;
          return 0;
        }
      }
      FILE *_tmp = fopen( BME2WAV::buf, "wb" );
      if ( _tmp == NULL ) {
        MessageBox( this->h_wnd, "o̓t@Cɏ߂܂", "ERROR", MB_ICONERROR );
        delete converter;
        return 0;
      }
      fclose( _tmp );
      this->volume_edit->get_text( BME2WAV::buf, sizeof( BME2WAV::buf ) );
      char *p;
      int volume = strtol( BME2WAV::buf, &p, 10 );
      if ( p == BME2WAV::buf ) {
        MessageBox( this->h_wnd, "ʂ𐳂w肵", "ERROR", MB_ICONERROR );
        delete converter;
        return 0;
      }
      converter->set_master_volume( volume );
      converter->set_resounding( !(this->resounding_check->get_check()) );
      converter->set_wnd_callback( this, (bool (TtWindow::*)( int ))(&MainFrame::exe_callback) );
      converter->set_wnd_wav_file_empty_callback( this, (bool (TtWindow::*)( char* ))(&MainFrame::wav_file_empty_callback) );
      TtWav *out_wav = converter->convert();
      if ( out_wav == NULL ) {
        sprintf( BME2WAV::buf, "WAVւ̕ϊs FILE : %s", converter->get_last_error_filename() );
        MessageBox( this->h_wnd, BME2WAV::buf, "ERROR", MB_ICONERROR );
        delete converter;
        return 0;
      }
      delete converter;
      this->output_edit->get_text( BME2WAV::buf, sizeof( BME2WAV::buf ) );
      if ( out_wav->write_file( BME2WAV::buf ) ) {
        this->info_label->set_text( "I WAVt@C֏݂܂" );
      }
      else {
        MessageBox( this->h_wnd, "WAVt@Cւ݂̏s", "ERROR", MB_ICONERROR );
        delete out_wav;
        return 0;
      }
      delete out_wav;
      return 0;
    }
  }
  return TtWindow::MSG_DEFAULT;
}

LRESULT MainFrame::wm_dropfiles_recved( HDROP h_drop ) {
  this->set_forground();

  DragQueryFile( h_drop, 0, BME2WAV::buf, sizeof( BME2WAV::buf ) );
  this->input_edit->set_text( BME2WAV::buf );
  TtPath::edit_path( BME2WAV::buf, true, true, true, false );
  strcat( BME2WAV::buf, ".wav" );
  this->output_edit->set_text( BME2WAV::buf );
  
  DragFinish( h_drop );
  return 0;
}

LRESULT MainFrame::wnd_proc( UINT msg, WPARAM w_param, LPARAM l_param ) {
  LRESULT ret;
  switch ( msg ) {
  case WM_DROPFILES:
    ret = this->wm_dropfiles_recved( (HDROP)w_param );
    if ( ret != TtWindow::MSG_DEFAULT ) { return ret; } else { break; }

  }
  return TtApp::wnd_proc( msg, w_param, l_param );
}


bool MainFrame::exe_callback( int percentage ) {
  this->progress->set_amount( percentage );
  if ( percentage == -1 ) {
    this->info_label->set_text( "WAVϊ ......" );
  }
  else if ( percentage == 0 ) {
    this->info_label->set_text( "WAVǂݍݒ" );
  }
  else if ( percentage == 100 ) {
    this->info_label->set_text( "WAVJn" );
  }
  return true;
}

bool MainFrame::wav_file_empty_callback( char *empty_filename ) {
  
  sprintf( BME2WAV::buf, "%s\ñt@C݂܂łBMSŎgĂȂ̂Őɕϊł܂B\nϊ܂H", empty_filename );
  if ( MessageBox( this->h_wnd, BME2WAV::buf, "ϊs܂H", MB_YESNO | MB_ICONQUESTION ) != IDYES ) { return false; }
  if ( MessageBox( this->h_wnd, "BMSIɐȂ񂾂H {ɕϊ̂H", "ϊs܂H", MB_YESNO | MB_ICONQUESTION ) != IDYES )  { return false; }
  MessageBox( this->h_wnd, "dȂAϊĂ܂", "ϊ܂", MB_OK | MB_ICONINFORMATION );
  return true;
}
